=== debian/changelog ===
simgrid (3.29+dfsg-1) unstable; urgency=medium

  * New upstream release v3.29: The "Ask a stupid question" release.
    Please ask a question about SimGrid e.g. on Mattermost:
    https://framateam.org/simgrid/channels/town-square
    - Python bindings for the platform creation API
    - Introduce non-linear resource sharing, allowing decay models
    - New documentation section on realistic I/O modeling
    - (+ many bug fixes and internal refactoring)

  * Mark libsimgrid3.29 as 'Multi-Arch: same'.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Martin Quinson <mquinson@debian.org>  Fri, 08 Oct 2021 00:55:34 +0200
